package com.ruoyi.project.ehs.controller;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.JSON;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.file.ExcelUtils;
import com.ruoyi.project.system.domain.SysDept;
import com.ruoyi.project.system.domain.SysDictData;
import com.ruoyi.project.system.service.ISysDeptService;
import com.ruoyi.project.system.service.ISysDictTypeService;
import org.apache.poi.ss.usermodel.*;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.project.ehs.domain.TFireextinguisher;
import com.ruoyi.project.ehs.service.ITFireextinguisherService;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.web.page.TableDataInfo;
import org.springframework.web.multipart.MultipartFile;

/**
 * 灭火器Controller
 *
 * @author ruoyi
 * @date 2020-11-25
 */
@RestController
@RequestMapping("/ehs/fireextinguisher")
public class TFireextinguisherController extends BaseController
{
    @Autowired
    private ITFireextinguisherService tFireextinguisherService;

    @Autowired
    private ISysDeptService iSysDeptService;

    @Autowired
    private ISysDictTypeService iSysDictTypeService;

    /**
     * 查询灭火器列表
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:list')")
    @GetMapping("/list")
    public TableDataInfo list(TFireextinguisher tFireextinguisher)
    {
        startPage();
        List<TFireextinguisher> list = tFireextinguisherService.selectTFireextinguisherList(tFireextinguisher);
        return getDataTable(list);
    }

    /**
     * 导出灭火器列表
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:export')")
    @Log(title = "灭火器", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(TFireextinguisher tFireextinguisher)
    {
        List<TFireextinguisher> list = tFireextinguisherService.selectTFireextinguisherList(tFireextinguisher);
        ExcelUtil<TFireextinguisher> util = new ExcelUtil<TFireextinguisher>(TFireextinguisher.class);
        return util.exportExcel(list, "fireextinguisher");
    }

    /**
     * 获取灭火器详细信息
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return AjaxResult.success(tFireextinguisherService.selectTFireextinguisherById(id));
    }

    /**
     * 新增灭火器
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:add')")
    @Log(title = "灭火器", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TFireextinguisher tFireextinguisher)
    {
        tFireextinguisher.setCreaterCode(getUserId().toString());
        return toAjax(tFireextinguisherService.insertTFireextinguisher(tFireextinguisher));
    }

    /**
     * 修改灭火器
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:edit')")
    @Log(title = "灭火器", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TFireextinguisher tFireextinguisher)
    {
        tFireextinguisher.setUpdaterCode(getUserId().toString());
        tFireextinguisher.setUpdatedate(new Date());
        return toAjax(tFireextinguisherService.updateTFireextinguisher(tFireextinguisher));
    }

    /**
     * 批量修改灭火器
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:edit')")
    @Log(title = "灭火器", businessType = BusinessType.OTHER)
    @RequestMapping("/batchEdit")
    public AjaxResult batchEdit(@RequestBody TFireextinguisher dto)
    {
        Long[] ids = dto.getIds();
        for (int i = 0; i < ids.length; i++) {
            TFireextinguisher t = new TFireextinguisher();
            t.setId(ids[i]);
            t.setRemarks(dto.getRemarks());
            t.setInspectstatus(dto.getInspectstatus());
            t.setUpdaterCode(getUserId().toString());
            t.setUpdatedate(new Date());
            tFireextinguisherService.updateTFireextinguisher(t);
        }
        return AjaxResult.success();
    }

    /**
     * 删除灭火器
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:remove')")
    @Log(title = "灭火器", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(tFireextinguisherService.deleteTFireextinguisherByIds(ids));
    }

    /**
     * 批量导入灭火器
     */
    @PreAuthorize("@ss.hasPermi('ehs:fireextinguisher:add')")
    @Log(title = "灭火器", businessType = BusinessType.INSERT)
    @PostMapping("/importData")
    public AjaxResult importData(@RequestParam("file") MultipartFile file) throws IOException
    {
        //获取操作人员ID
        Long userId = getUserId();
        //报错行数统计
        List<Integer> failRow =new ArrayList<Integer>();
        Workbook workbook = ExcelUtils.getWorkBook(file);
        Sheet sheet = workbook.getSheetAt(0);
        List<TFireextinguisher> list = new ArrayList<TFireextinguisher>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        //字典查询
        List<SysDictData> plant = iSysDictTypeService.selectDictDataByType("PLANT_DIVIDE");
        List<SysDictData> inspectstatus = iSysDictTypeService.selectDictDataByType("INSPECTSTATUS");
        //部门查询
        List<SysDept> dept = iSysDeptService.selectDeptList(new SysDept());
        int rowNum = sheet.getPhysicalNumberOfRows();
        int failNumber = 0;
        for (int i = 1; i < rowNum; i++) {
            try {
                logger.info("读取行数：" + i);
                Row row = sheet.getRow(i);
                int cellNum = row.getLastCellNum();
                TFireextinguisher entity = new TFireextinguisher();
                for (int j = 0; j < cellNum; j++) {
                    Cell cell = row.getCell(j);
                    //  cell.setCellType(CellType.STRING);
                    String cellValue = ExcelUtils.getCellValue(cell);
                    logger.info("cellValue:" + cellValue);
                    if (j == 0) {
                        for (SysDictData p : plant) {
                            if (p.getDictLabel().equals(cellValue.trim())) {
                                entity.setPlantCode(p.getDictValue());//装置名称
                            }
                        }
                    } else if (j == 1) {
                        entity.setLocation(cellValue);//位置
                    } else if (j == 2) {
                        entity.setName(cellValue);//器材名称
                    } else if (j == 3) {
                        entity.setNumb(cellValue);//编号
                    } else if (j == 4) {
                        if (cellValue != ""){
                            entity.setQuantity(Long.parseLong(cellValue));//数量
                        }
                    } else if (j == 5) {
                        entity.setInspector(cellValue);//检查人
                    } else if (j == 6) {
                        if (cellValue.length() > 3) {
                            entity.setUpinspectdate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));//检查日期/上旬
                        }
                    } else if (j == 7) {
                        if (cellValue.length() > 3) {
                            entity.setDninspectdate(new SimpleDateFormat(DateUtils.getDateFormat(cellValue)).parse(cellValue));//检查日期/下旬
                        }
                    } else if (j == 8) {
                        for (SysDictData p : inspectstatus) {
                            if (p.getDictLabel().equals(cellValue.trim())) {
                                entity.setInspectstatus(p.getDictValue());//检查状况
                            }
                        }
                    } else if (j == 9) {
                        for (SysDept d : dept) {
                            if (d.getDeptName().equals(cellValue.trim())) {
                                entity.setDeptId(d.getDeptId());//部门编号
                            }
                        }
                    } else if (j == 10) {
                        entity.setRemarks(cellValue);//备注
                    }
                }
                entity.setCreaterCode(userId.toString());
                logger.info("entity:" + entity);
                list.add(entity);
            }catch (Exception e){
                failNumber++;
                failRow.add(i+1);
            }
        }
        int successNumber = 0;
        int failNum = 0;
        for (TFireextinguisher t : list
        ) {
            failNum++;
            try {
                tFireextinguisherService.insertTFireextinguisher(t);
                successNumber++;
            }catch (Exception e){
                failNumber++;
                failRow.add(failNum+1);
            }
        }
        logger.info("list:" + JSON.toJSONString(list));
        logger.info("successNumber:" +String.valueOf(successNumber));
        logger.info("failNumber:" +String.valueOf(failNumber));
        logger.info("failRow:" +String.valueOf(failRow));
        return AjaxResult.success(String.valueOf(successNumber), failRow);
    }
}
